;Sprite Drawing Routine (SDR): 8 Bit Speed Version (White Transparency)and backgroud saved
;by JL
;<Joamail123@aol.com>
;
;Inputs:
;	b=x coordinate
;	c=y coordinate
;	hl=pointer to sprite data
;	ix=pointer to the area where the backgroud should be stored
;Outputs:
;	af=destroyed
;	bc=destroyed
;	de=destroyed
;	hl=pointer to byte after sprite
;	ix=pointer to byte after backgroud
;	no other registers are changed
;If you want to save those registers that are destroyed, push/pop them!
;
;Sprite data should be stored as follows:
;.db (# rows/bytes/height of sprite)
;.db (bitmap of sprite)
;
;Size=about 95 bytes (+pushes/pops)
;
;Notes:
;You can make this routine smaller by deleting the first 3 lines and
; accounting in your program the fact the the origin (0,0) is the *bottom*
; left corner (saves 4 bytes!).
;Also, if all your sprites are the same height, you can delete the next 2
; lines (ld e,(hl)\inc hl); change the 3rd line after that (ld c,e) to
; 'ld c,x', where x is the height of your sprites; and store all sprites
; with only the sprite data, leaving off that first byte that defines the
; height (saves 1 bytes + # of sprites!)
;If you want the sprite to be drawn in the graphics memory instead of the
; video memory, simply replace the destination address before running the sprite routine : 
;ld hl,VIDEO_MEM
;ld (DEST_ADDR),hl


SDR8SPBG:
 push bc
 ld a,63		
 sub c		
 ld c,a		
 ld e,(hl)		
 inc hl		
 ld (ix),e
 inc ix
 push hl		
 call FIND_PIXEL	
 ld c,e		
 ld de,(DEST_ADDR)
 add hl,de	

 add a,a	
 dec a	
 ld e,c
 ld c,a	
 ld a,b	
 and %00000111
 ld (&SDR8SPBG_PrepByte+1),a
 ld (&SDR8SPBG_PrepBG+1),a
 ld b,e

SDR8SPBG_NewRow:
 ex (sp),hl	
 ld a,(hl)	
 inc hl	
 ex (sp),hl

SDR8SPBG_PrepByte:
 jr 0	
 rlca\ rlca\ rlca\ rlca
 rlca\ rlca\ rlca\ rlca

 ld d,a	

 ld a,(hl)
 and c
 ld e,a

 ld a,d
 and c	
 or (hl)	
 ld (hl),a	
 inc hl	

 ld a,c
 cpl
 and (hl)
 or e
 ld e,a

 ld a,c	
 cpl		
 and d	
 or (hl)	
 ld (hl),a

 ld a,e
SDR8SPBG_PrepBG:
 jr 0
 rrca\  rrca\  rrca\  rrca
 rrca\  rrca\  rrca\  rrca
 ld (ix),a
 inc ix

 ld de,$10-1		;10
 add hl,de		;11

 djnz SDR8SPBG_NewRow
 pop hl			
 pop bc
 ret	

